/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#ifndef __MTK_TITLE_PAGE_H__
#define __MTK_TITLE_PAGE_H__


//-----------
//  Defines
//-----------
enum {
	TITLEPAGE_CREDITS,
	TITLEPAGE_ATTENTION,
	TITLEPAGE_TITLE,
	TITLEPAGE_THEME
};


//-------------
//  Constants
//-------------
//-- ^Cg
const bilingual bszTheaterTitle = {
	"4-Dimensional Digital Universe",
	"S{|}fW^{F|イ}VA^["
};

//-- e[}
const int ThemeNum = 7;
const bilingual bszTheme[ThemeNum] = {
	{ "Hierarchical Structure of the Universe", "{F|イ}{Kw\|}" },
	{ "Hierarchical Structure of the Universe", "{F|イ}{Kw\|}" },
	{ "Milky Way", " {V|}{|}{閧|Ђ݂}" },
	{ "Solar System",	"{znIs|悤}" },
	{ "Beyond the Solar System",	"{zn|悤}{z|}" },
	{ "World of Galaxies",	"{|}{E|}" },
	{ "Colliding Galaxies",	"{Փ|傤Ƃ}{|}" }
};

const bilingual bszTheme2[ThemeNum] = {
	{ "(Digest version)", "i_CWFXg{|΂}j" },
	{ "(Junior version)", "iWjA{|΂}j"    },
	{ "", "" },
	{ "", "" },
	{ "", "\Nɂ́H\" },
	{ "", "\͂̒a\" },
	{ "", "" }
};



//-------------
//  Functions
//-------------
void	draw_title_page();
void	set_title_page_no(int idx);
int		get_title_page_no();
void	set_title_width_ratio(float twr);
float	get_title_width_ratio();
void	set_theater_title_image_J(const char* fn);
void	set_theater_title_image_E(const char* fn);
void	set_title_duration(float dur);
float	get_title_duration();
void	set_title_zpos_ini(float z);
float	get_title_zpos_ini();



#endif
